import es
import cPickle, gamethread
from playerlib import getPlayer
from os.path import isfile as isFile
from cfglib import AddonCFG
from time import time as Time

config = AddonCFG(es.getAddonPath('player_rewards') + '/player_rewards_config.cfg')

config.text('********************************')
config.text('* Player Rewards Configuration *')
config.text('********************************')
config.text('\n')
config.text('* General Reward Settings *')
kill_points = config.cvar('kill_points', 1, 'This sets the number of points a player gets per kill')
player_time = config.cvar('player_time', 0.2, 'This sets the number of points a player gets every minute')
clip_upgrade = config.cvar('clip_upgrade', 5, 'This sets the amount of clip size increase')
armor_upgrade = config.cvar('armor_upgrade', 50, 'This sets the amount of armor increase')
health_upgrade = config.cvar('health_upgrade', 20, 'This sets the amount of health increase')
reset_months = config.cvar('reset_months', 1, "After this amount of months, the player's data will all be reset")
config.text('\n')
config.text('* How many points does a player have to have for... *')
upgrade_clip = config.cvar('upgrade_clip', 60, 'a clip upgrade?')
upgrade_armor = config.cvar('upgrade_armor', 120, 'an armor upgrade?')
upgrade_grenade = config.cvar('upgrade_grenade', 180, 'a grenade upgrade?')
upgrade_health = config.cvar('upgrade_health', 240, 'a health upgrade?')
config.text('\n')
config.text('* Messages *')
upgrade_message = config.cvar('upgrade_message', 1, '1 = Announce the player that he got the specific reward, 0 = Turn off')
announce_message = config.cvar('announce_message', 1, '1 = Announce every round that they get points every minute, 0 = Turn off')
config.text('\n')
config.text('********************************')
config.text('* Player Rewards Configuration *')
config.text('********************************')

config.write()

player = {}

class Rewards:
    def __init__(self, steam):
        self.userid = es.getuserid(steam)
        self.points = 0
        self.last_seen = Time()
    def _points(self):
        es.tell(self.userid, '#multi', '#green[#lightgreenPlayer Rewards#green] #defaultYour Points: #lightgreen%0.1f' % self.points)
    def death(self):
        self.points += float(kill_points)
        es.tell(self.userid, '#multi', '#green[#lightgreenPlayer Rewards#green] #defaultYour new Points: #lightgreen%0.1f' % self.points)
    def spawn(self):
        if announce_message:
            es.tell(self.userid, '#multi', "#green[#lightgreenPlayer Rewards#green] #defaultYou'll get #lightgreen%s #defaultPoints every minute." % player_time)
        self.last_seen = Time()
        player = getPlayer(self.userid)
        if self.points >= upgrade_clip:
            player.add('clip', ['secondary', str(clip_upgrade)])
            if upgrade_message:
                es.tell(self.userid, '#multi', "#green[#lightgreenPlayer Rewards#green] #defaultYou've got a #lightgreenClip Reward#default.")
        elif self.points >= upgrade_clip and self.points >= upgrade_armor:
            player.add('clip', ['secondary', str(clip_upgrade)])
            player.add('armor', str(armor_upgrade))
            if upgrade_message:
                es.tell(self.userid, '#multi', "#green[#lightgreenPlayer Rewards#green] #defaultYou've got a #lightgreenClip Reward #default+ an #lightgreenArmor Reward#default.")
        elif self.points >= upgrade_clip and self.points >= upgrade_armor and self.points >= upgrade_grenade:
            player.add('clip', ['secondary', str(clip_upgrade)])
            player.add('armor', str(armor_upgrade))
            es.server.queuecmd('es_xgive %s weapon_hegrenade' % self.userid)
            if upgrade_message:
                es.tell(self.userid, '#multi', "#green[#lightgreenPlayer Rewards#green] #defaultYou've got a #lightgreenClip Reward #default, an #lightgreenArmor Reward #default+ a #lightgreenGrenade Reward#default.")
        elif self.points >= upgrade_clip and self.points >= upgrade_armor and self.points >= upgrade_grenade and self.points >= upgrade_health:
            player.add('clip', ['secondary', str(clip_upgrade)])
            player.add('armor', str(armor_upgrade))
            player.add('health', str(health_upgrade))
            es.server.queuecmd('es_xgive %s weapon_hegrenade' % self.userid)
            if upgrade_message:
                es.tell(userid, '#multi', "#green[#lightgreenPlayer Rewards#green] #defaultYou've got a #lightgreenClip Reward #default, an #lightgreenArmor Reward #default, a #lightgreenGrenade Reward #default+ a #lightgreenHealth Reward#default.")
        gamethread.delayedname(60, 'pointgiving', self.give)
    def give(self):
        self.points += float(player_time)
        es.tell(self.userid, '#multi', '#green[#lightgreenPlayer Rewards#green] #defaultYour new Points: #lightgreen%0.1f' % self.points)
        gamethread.delayedname(60, 'pointgiving', self.give)

def load():
    global player
    config.execute()
    if not es.exists('saycommand', 'points'):
        es.regsaycmd('points', 'player_rewards/points')
    pl = es.getAddonPath('player_rewards') + '/players.db'
    if isFile(pl):
        pl = open(pl)
        player = cPickle.load(pl)
        pl.close()
    for userid in es.getUseridList():
        steam = unique(userid)
        player[steam] = Rewards(steam)

def unload():
    gamethread.cancelDelayed('pointgiving')
    es.unregsaycmd('points')
    save_file()

def save_file():
    pl = es.getAddonPath('player_rewards') + '/players.db'
    if isFile(pl):
        pl = open(pl, 'wb')
    else:
        pl = open(pl, 'w')
    cPickle.dump(player, pl)
    pl.close()

def unique(userid):
    uid = es.getplayersteamid(userid)
    if uid == 'BOT':
        uid = 'BOT_%s' % es.getplayername(userid)
    return uid

def es_map_start(ev):
    if reset_mounths == 1:
        seconds_to_trim = 720 * 3600
    elif reset_mounths == 2:
        seconds_to_trim = 1580 * 3600
    elif reset_mounths == 3:
        seconds_to_trim = 2160 * 3600
    elif reset_mounths == 4:
        seconds_to_trim = 2880 * 3600
    elif reset_mounths == 5:
        seconds_to_trim = 3600 * 3600
    elif reset_mounths == 6:
        seconds_to_trim = 4320 * 3600
    elif reset_mounths == 7:
        seconds_to_trim = 5040 * 3600
    elif reset_mounths == 8:
        seconds_to_trim = 5760 * 3600
    elif reset_mounths == 9:
        seconds_to_trim = 6480 * 3600
    elif reset_mounths == 10:
        seconds_to_trim = 7200 * 3600
    elif reset_mounths == 11:
        seconds_to_trim = 7920 * 3600
    elif reset_mounths == 12 or reset_mounths > 12:
        seconds_to_trim = 8640 * 3600
    for steam in filter(lambda x: Time() - player[x].last_seen > seconds_to_trim, player):
        del player[steam]
        player[steam] = Rewards(steam)

def points():
    player[es.getplayersteamid(es.getcmduserid())]._points()

def player_activate(ev):
    steam = unique(ev['userid'])
    if not player.has_key(steam):
        player[steam] = Rewards(steam)
    save_file()

def player_spawn(ev):
    player[unique(ev['userid'])].spawn()

def player_death(ev):
    player[unique(ev['attacker'])].death()

def round_end(ev):
    gamethread.cancelDelayed('pointgiving')

def player_disconnect(ev):
    save_file()
